	; "Sant"
	; Coded by Csabo/LOD, 2021-11-25

	org $0500-2
	dw  $0500

ptr		= $D0  
ptr_end		= $D2
count		= $D4  

start
	sei
	sta $ff3f
	;
	lda #charset >> 8
	sta $FF13 
	;
	ldx #$FD			; set up ted sound registers
	stx $FF0E
	inx
	stx $FF0F
	lda #$03
	sta $FF10
	lda #$C3
	sta $FF12
	;
	lda #$80			; digi playback speed (timer1)
	sta $FF00
	ldy #$00
	sty $FF01
	;
	ldx #digi_values & 255
	stx ptr
	inx
	stx ptr_end
	lda #digi_values >> 8
	sta ptr+1
	sta ptr_end+1
	;
	iny
	sty count
	;
	; ---
	;     
	lda #$A8			; enable timer1 interrupt only
	sta $FF0A
	;
	lda #irq & 255
	sta $FFFE
	lda #irq >> 8
	sta $FFFF
	;
	lda #$71
	sta $FF15
	sta $FF19
	;
	lda #$1B
	sta $FF06
	;
	cli
	;
	jmp *
         
irq	asl $FF09
	;
curr_digi_val
	ldy #$00
	lda digi_values,y
	sta $FF11
	;
	dec count
	bne irq_end
	;
	ldy #$00
	ldx #$01			; default value for count
	;
	inc toggle+1
toggle	lda #$00
	and #$01
	beq bit_lo			; digi order is low nibble first, then high nibble
	;
	lda (ptr),y
	lsr a
	lsr a
	lsr a
	lsr a
	cmp #$0F
	bne not_comp_hi
	;
	inc ptr				; first nibble was flag ($F)
	bne *+4
	inc ptr+1
	;
	lda (ptr),y			; next nibble (low) is count
	and #$0F
	tax
	lda (ptr),y			; 3rd nibble is data
	lsr a
	lsr a
	lsr a
	lsr a
	;
not_comp_hi
	sta curr_digi_val+1
	stx count
	;
	inc ptr
	bne *+4
	inc ptr+1
	;
	lda ptr
	cmp ptr_end
	bne irq_end
	lda ptr+1
	cmp ptr_end+1
	bne irq_end
	;
index	ldy #$00
	lda digi_ptrs_lo,y
	sta ptr
	lda digi_ptrs_hi,y
	sta ptr+1
	;
	lda digi_lengths_lo,y
	sta ptr_end
	lda digi_lengths_hi,y
	sta ptr_end+1
	;
	iny
	cpy #digi_ptrs_hi-digi_ptrs_lo
	bne *+4
	ldy #$00
	sty index+1
	;
irq_end	rti
	;
bit_lo	lda (ptr),y
	and #$0F
	cmp #$0F
	bne not_comp_lo
	;
	lda (ptr),y
	lsr a
	lsr a
	lsr a
	lsr a
	tax
	;
	inc ptr
	bne *+4
	inc ptr+1
	;
	lda (ptr),y
	and #$0F
not_comp_lo
	sta curr_digi_val+1
	stx count
	;
	rti

digi_values
	db $00,$91,$92,$93,$94,$95,$96,$97,$98,$36,$B5,$37,$B6,$B7,$B8
	
digi_ptrs_lo
	db part_00 & 255		; verse
	db part_00 & 255
	db part_00 & 255
	db part_21 & 255		; "Rosa"
	db part_03 & 255
	db part_00 & 255
	db part_23 & 255		; "Et toi, Albert"
	db part_05 & 255
	;
	db part_08 & 255		; chorus
	db part_08 & 255
	db part_10 & 255
	db part_0B & 255
	db part_11 & 255
	;
	db part_09 & 255		; chorus
	db part_08 & 255
	db part_10 & 255
	db part_0B & 255
	;
	db part_14 & 255		; "Frotter, frotter"
	db part_14 & 255
	db part_00 & 255		; verse
	db part_00 & 255
	;
	db part_08 & 255		; chorus
	db part_08 & 255
	db part_10 & 255
	db part_0B & 255
	db part_1C & 255
	;
	db part_09 & 255
	db part_08 & 255
	db part_10 & 255
	db part_0B & 255
	;
digi_ptrs_hi
	db part_00 >> 8
	db part_00 >> 8
	db part_00 >> 8
	db part_21 >> 8
	db part_03 >> 8
	db part_00 >> 8
	db part_23 >> 8
	db part_05 >> 8
	;
	db part_08 >> 8
	db part_08 >> 8
	db part_10 >> 8
	db part_0B >> 8
	db part_11 >> 8
	;
	db part_09 >> 8
	db part_08 >> 8
	db part_10 >> 8
	db part_0B >> 8
	;
	db part_14 >> 8
	db part_14 >> 8
	db part_00 >> 8
	db part_00 >> 8
	;
	db part_08 >> 8
	db part_08 >> 8
	db part_10 >> 8
	db part_0B >> 8
	db part_1C >> 8
	;
	db part_09 >> 8
	db part_08 >> 8
	db part_10 >> 8
	db part_0B >> 8
	;
digi_lengths_lo
	db part_08 & 255
	db part_08 & 255
	db part_01 & 255
	db part_23 & 255
	db part_08 & 255
	db part_01 & 255
	db digi_end & 255
	db part_08 & 255
	;
	db part_10 & 255
	db part_0A & 255
	db part_11 & 255
	db part_0E & 255
	db part_14 & 255
	;
	db part_10 & 255
	db part_0A & 255
	db part_11 & 255
	db part_10 & 255
	;
	db part_1C & 255
	db part_1C & 255
	db part_08 & 255
	db part_08 & 255
	;
	db part_10 & 255
	db part_0A & 255
	db part_11 & 255
	db part_0C & 255
	db part_21 & 255
	;
	db part_10 & 255
	db part_0A & 255
	db part_11 & 255
	db part_10 & 255
	;
digi_lengths_hi
	db part_08 >> 8
	db part_08 >> 8
	db part_01 >> 8
	db part_23 >> 8
	db part_08 >> 8
	db part_01 >> 8
	db digi_end >> 8
	db part_08 >> 8
	;
	db part_10 >> 8
	db part_0A >> 8
	db part_11 >> 8
	db part_0E >> 8
	db part_14 >> 8
	;
	db part_10 >> 8
	db part_0A >> 8
	db part_11 >> 8
	db part_10 >> 8
	;
	db part_1C >> 8
	db part_1C >> 8
	db part_08 >> 8
	db part_08 >> 8
	;
	db part_10 >> 8
	db part_0A >> 8
	db part_11 >> 8
	db part_0C >> 8
	db part_21 >> 8
	;
	db part_10 >> 8
	db part_0A >> 8
	db part_11 >> 8
	db part_10 >> 8
	
	org $0800
	db 0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0
	db 0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0
	db 0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0
	db 0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0
	db 0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0
	
	db 0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0
	db 0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0
	db 0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0
	db 0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0
	db 0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0
	
	db 0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0
	db 0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0
	db 0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0
	db 0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0
	db 0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0
	
	db 0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0
	db 0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0
	db 0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0
	db 0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0
	db 0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0
	
	align 256
	include "charmap.asm"
	
	align 256
	include "charset.asm"

	include "sante_6927.asm"
digi_end
;eof